-- name: [CS] Conan Edogawa
-- description: The main character of Detective Conan series\n\n\\#0a3f6c\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "Conan Edogawa"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CONAN = smlua_model_util_get_id("conan_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("Conan_Icon") -- Located in "textures"

-- All Located in "sound" Name them whatever you want. Remember to include the .ogg extension
local VOICETABLE_CONAN = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'conan_onetruth.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'conan_onetruth.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'conan_rensa5.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'conan_rensa3.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'conan_rensa9.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'conan_rensa2.ogg', 'conan_rensa1.ogg', 'conan_rensa8.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'conan_rensa7.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'conan_yippee.ogg', 'conan_rensa20.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'conan_uh.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'conan_haaaaai.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'conan_ahlele.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'conan_damage.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'conan_heh.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'conan_scream.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'conan_haaaaai.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'conan_heh.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'conan_onetruth.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'conan_finish.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'conan_damage.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'conan_weak.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'conan_scream2.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'conan_oioi.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'conan_yawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'conan_snore2.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'conan_snore.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'conan_cough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'conan_cough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'conan_cough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'conan_damage2.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'conan_scream.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'conan_oioi.ogg' -- Booted out of level
}

-- All Located in "actors"

local PALETTE_CONAN = {
    [PANTS]  = "75aacf",
    [SHIRT]  = "0a3f6c",
    [GLOVES] = "ffffff",
    [SHOES]  = "a60400",
    [HAIR]   = "574324",
    [SKIN]   = "fec179",
    [CAP]    = "a60400",
	[EMBLEM] = "ffffff"
}

local CSloaded = false
local function on_character_select_load()
    CT_CONAN = _G.charSelect.character_add("Conan Edogawa", {"Even if I'm smaller my brain is still that of a", "great detective, there is always only one truth!"}, "DavidHolandaOne, Warioplier", {r = 23, g = 142, b = 239}, E_MODEL_CONAN, CT_CONAN, TEX_CUSTOM_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_CONAN, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_CONAN, VOICETABLE_CONAN)
    _G.charSelect.character_add_celebration_star(E_MODEL_CONAN, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CONAN, PALETTE_CONAN)
    _G.charSelect.character_add_health_meter(CT_CONAN, HM_CONAN)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CONAN then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CONAN then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)